<?php
/*
Copyright 2016	Matthias Rauch
www.raapp.de

Dieses Programm ist freie Software. Sie können es unter den Bedingungen der GNU General Public License,
wie von der Free Software Foundation veröffentlicht, weitergeben und/oder modifizieren,
entweder gemäß Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von Nutzen sein wird,
aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben.
Falls nicht, siehe <http://www.gnu.org/licenses/>.

*/

session_start();

include("config.php");
include("funktionen.php");
pruefe_https();

if($raapp_login==1) { sessioncheck(1); }

$link=db_verbinden($db_host, $db_name, $db_user, $db_pass);

// ******** GPS Funktionen

function getGPS($fileName) {
	//get the EXIF
	$exif = exif_read_data($fileName);
	if(isset($exif["GPSLatitudeRef"])) {
		//get the Hemisphere multiplier
		$LatM = 1; $LongM = 1;
		if($exif["GPSLatitudeRef"] == 'S')
		{
			$LatM = -1;
		}
		if($exif["GPSLongitudeRef"] == 'W')
		{
			$LongM = -1;
		}
	
		//get the GPS data
		$gps['LatDegree']=$exif["GPSLatitude"][0];
		$gps['LatMinute']=$exif["GPSLatitude"][1];
		$gps['LatgSeconds']=$exif["GPSLatitude"][2];
		$gps['LongDegree']=$exif["GPSLongitude"][0];
		$gps['LongMinute']=$exif["GPSLongitude"][1];
		$gps['LongSeconds']=$exif["GPSLongitude"][2];
	
		//convert strings to numbers
		foreach($gps as $key => $value)
		{
			$pos = strpos($value, '/');
			if($pos !== false)
			{
				$temp = explode('/',$value);
				$gps[$key] = $temp[0] / $temp[1];
			}
		}
	
		//calculate the decimal degree
		$result['latitude'] = $LatM * ($gps['LatDegree'] + ($gps['LatMinute'] / 60) + ($gps['LatgSeconds'] / 3600));
		$result['longitude'] = $LongM * ($gps['LongDegree'] + ($gps['LongMinute'] / 60) + ($gps['LongSeconds'] / 3600));
		return $result;
	} else { return(0); }
}
// ***** Ende GPS Funktionen

function bild_anzeigen ($m, $n, $play) {
	include("config.php");
	global $link;
	
	$abfrage="Select photo_daten.* from photo_daten join photo_playlist on photo_daten.satz=photo_playlist.pl_satz Limit $n,1";
	$erg = mysqli_query($link, $abfrage);
	$mybild=mysqli_fetch_object($erg);
// HTML-Header ausgeben
	if ( $play==1) {
		echo "<!DOCTYPE html><HTML>
		<head><META HTTP-EQUIV='CONTENT-TYPE' CONTENT='text/html; charset=UTF-8'>";
		if( $n<$_SESSION['anzahl_bilder']-1) {
			$n++;
			echo "<META HTTP-EQUIV='refresh' CONTENT='" . $_SESSION['bildpause'] . "; URL=bilder.php?m=$m&n=$n&play=1&pause=0'>";
			 } else {
			$n++;
			echo "<META HTTP-EQUIV='refresh' CONTENT='" . $_SESSION['bildpause'] . "; URL=bilder.php?m=$m&n=0&play=1&pause=0'>";
			}
		echo "<TITLE>". $_SESSION['albumname'] . "</TITLE><META HTTP-EQUIV='Content-Language' CONTENT='de'>
			<link rel='stylesheet' type='text/css' href='stiel.css'>
			</HEAD>
			<BODY>";
	} else {
			htmlkopf();
	}
	
	$_SESSION['bild']="../" . hole_verzeichnisname1 ($mybild->verz1_id) . "/" . hole_verzeichnisname2 ($mybild->verz2_id) . "/" . $mybild->bild;
	
	echo "<div id='Bild'>";
	bild_video_anzeigen($mybild,$_SESSION['BildAnzeigeModus']);
	echo "</div>";
	echo "<div id='map' class='map'></div>";
	
// Seitennavigation anzeigen
	echo "<div id='Text'><div id='buttonblock'><div id='verzzeile'>";
	if($raapp_login==1) {
		echo "<a class='verz_button' href='index.php?logout=1' onmouseover='InfoBoxAnzeigen(event,info[20],20,-30);' onmouseout='InfoBoxAusblenden();'><img src='../bin/images/b_logout.png'></a>";
	}
	echo " <a class='verz_button' href='../index.html'><img src='../bin/images/b_home.png' alt='Home'></a>
			<A class='verz_button' HREF='verz_anz2.php?v1=$mybild->verz1_id&v2=$mybild->verz2_id&sw=0'><IMG SRC='../bin/images/b_verzo.png' alt='zur&uuml;ck'></A>
			 ";
		if($play==1) {
			 $nstop=$n-1;
			 echo "</div><div id='verzzeile'><a class='verz_button' href='bilder.php?m=$m&play=0&n=$nstop&pause=0'><img src='../bin/images/b_stopp.png' alt='stop'></a>
			 <a class='verz_button' href='bilder.php?m=$m&play=1&n=$n&pause=1'><img src='../bin/images/b_plus.png' alt='schneller'></a>
			 <a class='verz_button' href='bilder.php?m=$m&play=1&n=$n&pause=2'><img src='../bin/images/b_minus.png' alt='langsamer'></a>
			 </div>";
		} else {
			 echo "<a class='verz_button' href='bilder.php?m=$m&play=1&n=$n&pause=0'><img src='../bin/images/b_autom.png' alt='play'></a>";

			if (preg_match('/.JPG/i', $mybild->bild)) {
				$erggps=getGPS($_SESSION['bild']);	// GPS-Koordinaten aus Bild holen
			} else {
				$erggps['longitude']=0;	// Bei Video mit 0 füllen damit keine Karte angezeigt wird
			}

			// hier wird der Globus Button und die Landkarte angezeigt fals Koordinaten im Bild vorhanden
			if($erggps['longitude']!=0) {
				// hier wird das Bild oder die Karte ein und ausgeschaltet nachdem Sie über die Funktion drawmap erstmalig angezeigt wurden
				echo "<script type='text/javascript'>
						function drawbild() {
							document.getElementById ('Bild').style.display = 'block';
							document.getElementById ('map').style.display = 'none';

							document.getElementById('b_globus').innerHTML=' <A class=\'verz_button\' onclick=(drawmap1())><IMG SRC=\'../bin/images/b_globus.png\'></A>';
						}
						
						function drawmap1() {
							document.getElementById ('Bild').style.display = 'none';
							document.getElementById ('map').style.display = 'block';
							
							document.getElementById('b_globus').innerHTML=' <A class=\'verz_button\' onclick=(drawbild())><IMG SRC=\'../bin/images/b_anzeigen.png\'></A>';
						}
						</script>";
				
				if($_SESSION['karte']==0) {
					// **************  hier kommt die openstreetmap
					
					echo "<style>
						.map {
							position: relative;
					        height: 100%;
					        width: 100%;
					      }
					    </style>
							
						<script src='https://cdn.polyfill.io/v2/polyfill.min.js?features=requestAnimationFrame,Element.prototype.classList,URL'></script>
					    <script src='https://openlayers.org/en/v4.1.0/build/ol.js'></script>";

					echo "<script>function drawmap() {
						document.getElementById ('Bild').style.display = 'none';
						document.getElementById('b_globus').innerHTML=' <A class=\'verz_button\' onclick=(drawbild())><IMG SRC=\'../bin/images/b_anzeigen.png\'></A>';

						var lon = " . $erggps['longitude'] . ";
						var lat = " . $erggps['latitude'] . ";
								
						var Bildposition = new ol.Feature({	geometry: new ol.geom.Point(ol.proj.fromLonLat([lon, lat]))	 });
						var Bildtext = '';					
									
						Bildposition.setStyle(new ol.style.Style({
   							image: new ol.style.Icon({	src: './images/KarteMarker.png'	}),
							text: new ol.style.Text({ font: '12px Calibri,sans-serif', offsetY: -20, text: Bildtext }) /* hier kann beliebiger Text stehen */
   						}));
									
						var vectorSource = new ol.source.Vector({	features: [Bildposition]	});
   						var vectorLayer = new ol.layer.Vector({	source: vectorSource	});
									
					    var map = new ol.Map({
					        target: 'map',
					        layers: [	new ol.layer.Tile({	source: new ol.source.OSM()	}), vectorLayer ],
					        view: new ol.View({	center: ol.proj.fromLonLat([lon, lat]),
					        zoom: 15
					        })
					      });
					   }</script>";
					
					echo "<span id='b_globus'> <A class='verz_button' onclick=(drawmap())><IMG SRC='../bin/images/b_globus.png'></A></span>";
				
				} else { // **************  hier kommt die Google Map
					echo "<script type='text/javascript'>
					function drawmap() {
						
						document.getElementById ('Bild').style.display = 'none';
						document.getElementById('b_globus').innerHTML=' <A class=\'verz_button\' onclick=(drawbild())><IMG SRC=\'../bin/images/b_anzeigen.png\'></A>';
						
						var lon = " . $erggps['longitude'] . ";
						var lat = " . $erggps['latitude'] . ";
						var Fw = Fensterweite()-380;
						var Fh = Fensterhoehe();
								
						var googlelink = 'https://www.google.com/maps/embed/v1/view?key=" . $_SESSION['goglkey'] . "&center=' + lat + ',' + lon + '&zoom=15&maptype=satellite';
						var inhaltMap = '<iframe width=' + Fw + ' height=' + Fh + '	frameborder=\'0\' style=\'border:0\' src=' + googlelink + ' allowfullscreen></iframe>';
						document.getElementById('map').innerHTML=inhaltMap;
					}
					</script>";
					
					echo "<span id='b_globus'> <A class='verz_button' id='b_globus' onclick=(drawmap())><IMG SRC='../bin/images/b_globus.png'></A></span>";
				}
			}
			echo "</div>";
			 
// Bildernavigation anzeigen
			echo "<div id='verzzeile'>";
			$n++;
			if($n-1>0) {
				$nl=$n-2;
				echo "<A class='verz_button' id='js_pfeilll' HREF='bilder.php?m=$m&n=0&pause=0&play=0'><IMG SRC='../bin/images/b_pfeilll.png'></A>
				<A class='verz_button' id='js_pfeill' HREF='bilder.php?m=$m&n=$nl&pause=0&play=0'><IMG SRC='../bin/images/b_pfeill.png'></A>";
			} else {
				echo " <A class='verz_button'><IMG SRC='../bin/images/b_leer.png'></A>
				<A class='verz_button'><IMG SRC='../bin/images/b_leer.png'></A>";
			}
			
			if($n<$_SESSION['anzahl_bilder']){
				$nrr=$_SESSION['anzahl_bilder']-1;
				echo "
				<A class='verz_button' id='js_pfeilr' HREF='bilder.php?m=$m&n=$n&pause=0&play=0'><IMG SRC='../bin/images/b_pfeilr.png'></A>
				<A class='verz_button' id='js_pfeilrr' HREF='bilder.php?m=$m&n=$nrr&pause=0&play=0'><IMG SRC='../bin/images/b_pfeilrr.png'></A>";
			} else {
				echo " <A class='verz_button'><IMG SRC='../bin/images/b_leer.png'></A>
				<A class='verz_button'><IMG SRC='../bin/images/b_leer.png'></A>";
			}

			echo "</div></div>";
		}
// Bildinformationen anzeigen
	if ($_SESSION['BildAnzeigeModus'] !=2 ) {
		echo "<div id='textinfo'><P CLASS='text1'>" . hole_verzeichnisname2 ($mybild->verz2_id) . "</P>
				 <P CLASS='text2'>$mybild->bild &nbsp; &nbsp; $n / " . $_SESSION['anzahl_bilder'] ."</P><hr>
				 <P CLASS='text1'>$mybild->tag.$mybild->monat.$mybild->jahr</P>
				<P ALIGN='CENTER'>$mybild->person</P>
				<P ALIGN='CENTER'>$mybild->bildtext</P>
				</div></div>";
	}
}
// ********  Ende function bild_anzeigen



// *** Hauptsteuerung Script

if( ! isset($_GET['sw'])) {
	// Variablen aus URL zuweisen

	$m=$_GET['m'];			// m=0 komme vom Verzeichnis und die Playlist mu� erstellt werden
							// m=1 Playlist ist bereits erstellt
	$n=$_GET['n'];			// n= aktuelle Position in der Playlist
							// bs=1 komme aus Suchformular
	$pause=$_GET['pause'];	// pause=1 entspricht Pause
							// play 1=automatisch abspielen, 0= von Hand

	if ($_GET['m']==0) {
		// Abfrage aus Suchformular kommen ?
		if($_GET['bs']==1) {
			$frageparam=frageparam_bauen($_GET, $_SESSION['privat']);
	  		} else { 
	  			if(isset($_GET['v2'])) { $tmpGv2=$_GET['v2']; } else { $tmpGv2=""; }
	  			
	  	  		$frageparam=array(	array("and","","verz1_id","gleich",$_GET['v1'],""),
								array("and","","verz2_id","gleich",$tmpGv2,""),
	  							array("and","","privat","<",$_SESSION['privat'],"")
	  						  );
	  		}
		$frage=fragebauen1($frageparam);
		mysqli_query($link, "DELETE from photo_playlist");

		$abfrage = "Insert into photo_playlist SELECT satz from photo_daten $frage";
		$erg = mysqli_query($link, $abfrage);
		$_SESSION['anzahl_bilder'] = mysqli_affected_rows($link);
	
		$m=1;
		$n=0;
		}
		
	if ($pause==1 && $_SESSION['bildpause']>1) { $_SESSION['bildpause']=$_SESSION['bildpause'] - 1; }
	if ($pause==2) { $_SESSION['bildpause']=$_SESSION['bildpause'] + 1; }
	
	if($_SESSION['anzahl_bilder'] >0) {
		bild_anzeigen ($m, $n, $_GET['play']);
	} else {
		htmlkopf();
		echo "<div id='container'>
		<div id='kopf'>". $_SESSION['albumname'] . "</div>
		<div id='btop'><a  class='top_button' href='../index.html'><img src='../bin/images/b_home.png' alt='Home'></a>
		<a class='top_button' href='bildersuch.php?sw=0'><img src='../bin/images/b_suchen.png' alt='suchen'></a>
		<a class='top_button' href='../bin/beschreibung.php'><img src='../bin/images/b_hilfe.png' alt='Hilfe'></a>
		</div>";
		echo "Keine Bilder zum anzeigen gefunden<br>";
		if($_GET['bs']==1) {
			echo "Keine Bilder gefinden, bitte &aumlndern Sie die Suchkriterien<br>";
		} else {
			echo "M&ouml;glicherweise haben Sie den Privatmodus eingeschaltet<br>";
		}
	}
	htmlfuss();
	mysqli_close($link);
} else { // AJAX Handling für BildAnzeigeModus
	switch ($_GET['sw']) {
		case 2:		// gross
					$_SESSION['BildAnzeigeModus']=2;
					echo "0";
					break;
				
		default:	// klein
					$_SESSION['BildAnzeigeModus']=0;
					echo "0";
					break;
	}
}
?>
