<?php
/*
Copyright 2017	Matthias Rauch
www.raapp.de

Dieses Programm ist freie Software. Sie können es unter den Bedingungen der GNU General Public License,
wie von der Free Software Foundation veröffentlicht, weitergeben und/oder modifizieren,
entweder gemäß Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von Nutzen sein wird,
aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben.
Falls nicht, siehe <http://www.gnu.org/licenses/>.

*/

function htmlkopf() {
	echo "<!DOCTYPE html>
	<html><head>
	<meta charset='UTF-8'>
	<meta name='description' content='Photo- und Videoalbum'>
	<meta name='keywords' content='HTML,CSS,XML,JavaScript'>
	<meta name='author' content='Matthias Rauch'>
	<meta name='viewport' content='width=device-width, initial-scale=1.0, user-scalable=no'>
	
	<TITLE>raAPP Photo</TITLE>

	<link rel='stylesheet' type='text/css' href='stiel.css'>
			<link rel='stylesheet' href='https://openlayers.org/en/v4.1.0/css/ol.css'>
	<link rel='shortcut icon' type='image/x-icon' href='./images/favicon.ico'>
	<link rel='icon' type='image/png' href='./images/raAPPPhotoLogo32x24.png' sizes='32x32'>
	<link rel='apple-touch-icon-precomposed' sizes='180x180' href='./images/raAPPPhotoLogo.png' />
	
	<script src='funktionen.js' type='text/javascript'></script>
	</head><body><div id='InfoBox' ><div id='BoxInnen'><span id='BoxInhalte'></span></div></div>";
}

function htmlfuss() {
	echo "</body></html>";
}

function pruefe_https(){
	if (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off')
		return true;
		else {
			// Ausser im lokalen Netz ( IP 192. und IP 127. ) immer zu https redirecten
			if(strncmp($_SERVER['SERVER_ADDR'],'127.', 4)!==0 && strncmp($_SERVER['SERVER_ADDR'],'192.', 4)!==0 && strncmp($_SERVER['SERVER_NAME'],'localhost', 9)!==0) { 
				$urlredirect = 'https://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
				header("Location: " . $urlredirect);
				exit;
			}
		}
}

function check_nutzer($post) {
	include("config.php");

	if (isset($_SESSION['versuch']) && $_SESSION['versuch']>2) {
		return false;
	}

	if (!isset($_SESSION['auth']) && !isset($post['username'])) {
		return false;
	}

	if (isset($post['username'])) {
		if (!isset($_SESSION['versuch'])) {
			$_SESSION['versuch']=1;
		} else {
			$_SESSION['versuch']++;
		}

		if (!isset($_COOKIE[session_name()])) {
			return false;
		}

		// Security um einschleusen von Code über das Formular zu verhindern
		$nutzer = trim($post['username']);
		$nutzer = stripslashes($nutzer);
		$nutzer = htmlspecialchars($nutzer);
		$pwd = trim($post['passwort']);
		$pwd = stripslashes($pwd);
		$pwd = htmlspecialchars($pwd);
		
		if (strlen($nutzer)<3) {
			return false;
		}
		$r=check_photo_usr($nutzer,$pwd);
		if ( $r['ret'] == 3) {
			$_SESSION['auth']=$nutzer;
			return true;
		} else {
			return false;
		}
	}
}

/* liefert 0 keine Anmeldung, 1 bei inaktiv, 2 bei Mailadresse OK, 3 bei Mailadresse und passw ok */
function check_photo_usr($mailadresse, $pwd) {
	global $link;

	$abfrage = "SELECT id, mailadresse, passw, typ, aktiv from photo_usr where mailadresse like '" . $mailadresse . "'";
	$erg = mysqli_query($link, $abfrage);
	list($usrid, $mailadresse, $passw, $typ, $aktiv)=mysqli_fetch_row($erg);
	$r= array('ret'=>0,'usrid'=>0);
	$p=password_verify($pwd,$passw);
	
	if($usrid>0 and $p===FALSE) { $r['ret']=2; $r['usrid']=$usrid; }
	if($usrid>0 and $p===TRUE and $aktiv==1) {
		$r['ret']=3;
		$r['usrid']=$usrid;
		$_SESSION['GlobalEmail']=$mailadresse;
		$_SESSION['GlobalUsrtyp']=$typ;
		$_SESSION['versuch']="";
	}
	if($aktiv==0) { $r['ret']=1; $r['usrid']=$usrid; }
	$r['usrid']=$usrid;
	return($r);
}

// art=0 liefert True oder False, art=1 prüft und fordert zur Anmeldung auf
function sessioncheck($art) {
	if($art===0) {
		if(isset ($_SESSION['GlobalEmail'])) {
			return(TRUE);
		} else {
			return(FALSE);
		}
	} else {
		if (! isset ($_SESSION['GlobalEmail'])) {
			htmlkopf();
			zeige_starttopl();
			echo "<div id='start-mitte'>
					<p>Sie sind noch nicht angemeldet.<br><br>
					Bitte melden Sie sich mit Ihrer<br>Benutzerkennung und Ihrem Passwort an.</p>
					<a href='../index.html'>zum Login</a>
			</div>";
			zeige_startrunten();
			htmlfuss();
			exit();
		}
	}
}

function zeige_starttopl() {
	echo "<div id='start'>
	<p class='ueberschrift'>" . $_SESSION['albumname'] . "</p>
			<div id='start-top'>
			<img src='../bin/images/bild1.jpg'><img src='../bin/images/bild2.jpg'><img src='../bin/images/bild3.jpg'><img src='../bin/images/bild4.jpg'><img src='../bin/images/bild5.jpg'><img src='../bin/images/bild6.jpg'>
			</div>
			<div id='start-mittel'>
			<img src='../bin/images/bild7.jpg'><img src='../bin/images/bild8.jpg'><img src='../bin/images/bild9.jpg'><img src='../bin/images/bild10.jpg'><img src='../bin/images/bild11.jpg'>
			</div>";
}

function zeige_startrunten() {
	echo "<div id='start-mitter'>
		<img src='../bin/images/bild12.jpg'><img src='../bin/images/bild13.jpg'><img src='../bin/images/bild14.jpg'><img src='../bin/images/bild15.jpg'><img src='../bin/images/bild16.jpg'>
	</div>
	<div id='start-fuss'>
		<img src='../bin/images/bild17.jpg'><img src='../bin/images/bild18.jpg'><img src='../bin/images/bild19.jpg'><img src='../bin/images/bild20.jpg'><img src='../bin/images/bild21.jpg'><img src='../bin/images/bild22.jpg'>
	</div>
	</div>
	<p class='text1'>";
	// Kontakt, Datenschutz, Impressum wird im lokalen Netz auf localhost ip 127 und 192 nicht benötigt, ::1 (IPv6) entspricht 127.0.0.1 (ipV4)
	if(strncmp($_SERVER['SERVER_ADDR'],'127.', 4)!==0 && strncmp($_SERVER['SERVER_ADDR'],'192.', 4)!==0 && strncmp($_SERVER['SERVER_ADDR'],'::1', 3)!==0) {
		echo "<script language='JavaScript' type='text/javascript'>
			var p1='kontakt';
			var p2=Math.pow(2,6);
			var p3=String.fromCharCode(p2);
			var p4='raapp.de';
			document.write('<a href=' + 'ma' + 'ilto' + ':' + p1 + p3 + p4 + '>Kontakt</a>');
			</script>
			 | <A HREF='../../datenschutz.php'>Datenschutz</A> | <A HREF='../../impressum.php'>Impressum</A> | ";
	}
	if(empty($_SESSION['photoversion'])) {	$_SESSION['photoversion']="";	}
	echo "raAPP Photo " . $_SESSION['photoversion'] . " &copy;2017 <A href='https://www.raapp.de'>raAPP.de</A></p>";
}

function db_verbinden($db_host, $db_name, $db_user, $db_pass) {
	$link=mysqli_connect($db_host,$db_user,$db_pass,$db_name );
	if (! $link)
		die ( "Keine Verbindung zu MySQL !");
	// Einstellen zeichensatz für Kommunikation Client mit der Datenbank
	mysqli_query($link, "SET NAMES 'utf8'");
	mysqli_query($link, "SET CHARACTER SET 'utf8'");

	return $link;
}

// Liest alle Parameter aus der config.xml und speichert Sie in Session Variablen ab

function config_xml_lesen() {
if (file_exists('config.xml')) {
    $xml = simplexml_load_file('config.xml');
//    print_r($xml);
} else {
    exit('Konnte config.xml nicht �ffnen.');
}
$_SESSION['albumname']=(string)$xml->albumname;
$_SESSION['bildexport']=(string)$xml->bildexport;
$_SESSION['karte']=(string)$xml->karte;
$_SESSION['goglkey']=(string)$xml->goglkey;
$_SESSION['speicherlimit']=(string)$xml->speicherlimit;
$_SESSION['bbr1']=(string)$xml->{'fenster'}->bbr1;
$_SESSION['bhr1']=(string)$xml->{'fenster'}->bhr1;
$_SESSION['szeilen']=(string)$xml->{'fenster'}->szeilen;
$_SESSION['dev_vname1']=(string)$xml->{'namen'}->vname1;
$_SESSION['dev_nname1']=(string)$xml->{'namen'}->nname1;
$_SESSION['dev_vname2']=(string)$xml->{'namen'}->vname2;
$_SESSION['dev_nname2']=(string)$xml->{'namen'}->nname2;
$_SESSION['dev_vname3']=(string)$xml->{'namen'}->vname3;
$_SESSION['dev_nname3']=(string)$xml->{'namen'}->nname3;
$_SESSION['dev_vname4']=(string)$xml->{'namen'}->vname4;
$_SESSION['dev_nname4']=(string)$xml->{'namen'}->nname4;
$_SESSION['tmpbildbreite']=(string)$xml->{'bilder'}->tmpbildbreite;
$_SESSION['bildpause']=(string)$xml->{'bilder'}->bildpause;
$_SESSION['videobreite']=(string)$xml->{'video'}->videobreite;
$_SESSION['par_mts_mp4']=(string)$xml->{'video'}->par_mts_mp4;
$_SESSION['par_avi_mp4']=(string)$xml->{'video'}->par_avi_mp4;
$_SESSION['par_mts_flv']=(string)$xml->{'video'}->par_mts_flv;
$_SESSION['par_mts_avi']=(string)$xml->{'video'}->par_mts_avi;
$_SESSION['par_mts_wmv']=(string)$xml->{'video'}->par_mts_wmv;
}

function xml_vartest($v) {
	if(isset($_SESSION[$v])) {
		return(TRUE);
	} else {
		return(FALSE);
	}
}

function xml_varschreiben($v, $w) {
	$filename="config.xml";
	// config.xml um den Eintrag für die Karte erweitern
	if (file_exists($filename)) {
		$xml = simplexml_load_file($filename);
		//    print_r($xml);
	} else {
		echo "Datei config.xml existiert nicht";
		return(FALSE);
	}
	$xml->addChild($v, $w);

	if (is_writable($filename)) {
		if(!$handle = fopen($filename, "wb")){
			echo "Datei config.xml kann nicht geöffnet werden";
			return(FALSE);
		}
		if(!fwrite($handle, $xml->asXML())) {
			echo "Fehler beim zufügen des xml Parameters";
			return(FALSE);
		}
		fclose($handle);
	} else {
		echo "Datei config.xml ist nicht beschreibbar";
		return(FALSE);
	}
}

function erstelle_tabellen($link) {
	include("conf_tables.php");
	echo "<h3><br>Die Datenbanktabellen werden erstellt</h3><ul>";

	foreach($tabellen as $tabelle) {
		$abfrage="DROP TABLE IF EXISTS `" . $tabelle . "`";
		$erg=mysqli_query($link, $abfrage);
		echo "<li>Tabelle $tabelle gel&ouml;scht</li>";

		$create="create_" . $tabelle;
		$erg=mysqli_query($link, $$create);
		echo "<li>Tabelle $tabelle erzeugt</li>";
	}
	echo "</ul>";
}

function bildtest ($fbreite,$fhoehe) {
	if (betriebssystem()==2) { // für Windows wegen ISO 8859-1
		$groesse=getimagesize(utf8_decode($_SESSION['bild'])); 
	} else {
		$groesse=getimagesize($_SESSION['bild']);
	}
if($groesse[0]>$groesse[1]) {
	$divisor=$groesse[0]/($fbreite-$_SESSION['bbr1']);
} else {
	$divisor=$groesse[1]/($fhoehe-$_SESSION['bhr1']);
}
echo "erster Divisor: $divisor<br>";
$neuebreite=($groesse[0]/$divisor);
$neuehoehe=$groesse[1]/$divisor;

if($neuehoehe>($fhoehe-$_SESSION['bhr1'])) {
	$divisor=$groesse[1]/($fhoehe-$_SESSION['bhr1']);
	$neuebreite=($groesse[0]/$divisor);
	$neuehoehe=$groesse[1]/$divisor;
	echo "neuer Divisor wegen neuehoehe > fensterhoehe: $divisor<br>";
}

if($neuebreite>($fbreite-$_SESSION['bhr1']-200)) {
	$b=($fbreite-$_SESSION['bhr1']-200)/$neuebreite;
	$divisor=$divisor/$b;
	$neuebreite=($groesse[0]/$divisor);
	$neuehoehe=$groesse[1]/$divisor;
	echo "neuer Divisor wegen neuebreite > fensterbreite: $divisor<br>";
}

echo "Breite groesse0: $groesse[0]<br>";
echo "Hoehe groesse1: $groesse[1]<br>";
echo "bild: " . $_SESSION['bild'] . "<br><br>";
echo "fensterbreite: " . $fbreite . "<br>";
echo "fensterhoehe: " . $fhoehe . "<br>";
echo "bbr1: " . $_SESSION['bbr1'] . "<br>";
echo "bhr1: " . $_SESSION['bhr1'] . "<br><br>";
echo "divisor: $divisor<br><br>";
echo "neuebreite: $neuebreite <br>";
echo "neuehoehe: $neuehoehe <br>";
$bild=$_SESSION['bild'];
echo "<img src='$bild'>";
return (0);
}

function bild_video_anzeigen($mybild,$modus) {
$bedienflaechen_kl="<div class='links'>
	<div class='links_omu' onclick='Bild_Klein()'></div>
	<div class='links_omu' onclick='Bild_Link(\"js_pfeill\")'></div>
	<div class='links_omu' onclick='Bild_Link(\"js_pfeilll\")'></div>
	</div>
	<div class='rechts'>
	<div class='rechts_omu' onclick='Bild_Gross()'></div>
	<div class='rechts_omu' onclick='Bild_Link(\"js_pfeilr\")'></div>
	<div class='rechts_omu' onclick='Bild_Link(\"js_pfeilrr\")'></div>
	</div>";

$bedienflaechen_gr="<div class='links_gr'>
	<div class='links_omu' onclick='Bild_Klein()'></div>
	<div class='links_omu' onclick='Bild_Link(\"js_pfeill\")'></div>
	<div class='links_omu' onclick='Bild_Link(\"js_pfeilll\")'></div>
	</div>
	<div class='rechts_gr'>
	<div class='rechts_omu' onclick='Bild_Gross()'></div>
	<div class='rechts_omu' onclick='Bild_Link(\"js_pfeilr\")'></div>
	<div class='rechts_omu' onclick='Bild_Link(\"js_pfeilrr\")'></div>
	</div>";

// Bild anzeigen
	if (preg_match('/.JPG/i', $mybild->bild)) {
		
		// mysql und Browser arbeitet mit utf8 Windows mit Iso8859-1 deshalb decodieren für Windows
		if (betriebssystem()==2) {
			$_SESSION['bild']=utf8_decode($_SESSION['bild']);
		}
		
		echo "<script src='funktionen.js' type='text/javascript'></script>";
		switch ($modus) {
			case 1:			// Bild ganz klein anzeigen
					echo "<script>
							var h=Fensterhoehe()-100;
							var w=Fensterweite()-100;
							document.write('<img src=\"bild.php?h=' + h + '&b=' + w + '\" width=\"100%\">');
							</script>";
					break;
					
			case 2:			// Bild gross anzeigen
					echo $bedienflaechen_gr;
					// Bild gross anzeigen
					echo "<script>
					document.write('<img src=\"bild.php?h=' + Fensterhoehe() + '&b=' + Fensterweite() + '\" width=\"125%\">');
					</script>";
					break;
					
			default:		// Bild normal anzeigen
					echo $bedienflaechen_kl;
					echo "<script>
			 		document.write('<img src=\"bild.php?h=' + Fensterhoehe() + '&b=' + Fensterweite() + '\" width=\"100%\">');
			 		</script>";
					break;
		}
		// bildtest(breite_eingeben, hoehe eingeben);
	} else {
// Video anzeigen
		echo "<script>
		b=Fensterweite()-" . $_SESSION['videobreite'] . ";
		v='<video width=\"' + b + '\" controls>';
		v+='<source src=\"" . $_SESSION['bild'] . "\" type=\"video/mp4\">Dein Browser unterst&uuml;tz das Video Tag nicht.</video>';
		document.write(v);
		</script>";
	}
}

function video_klein_anzeigen() {
		echo "<script>
		b=200;
		v='<video width=\"' + b + '\" controls>';
		v+='<source src=\"" . $_SESSION['bild'] . "\" type=\"video/mp4\">Dein Browser unterst&uuml;tz das Video Tag nicht.</video>';
		document.write(v);
		</script>";
}

// erzeugt die tempor�ren Bilder f�r die Suchliste
function tmpbild($i) {
	ini_set('memory_limit', $_SESSION['speicherlimit']);
	$dateiname='../bin/images/tmpbilder/tmpbild' . $i . '.jpg';
	
	if (betriebssystem()==2) { // für Windows wegen ISO 8859-1
		$file=utf8_decode($_SESSION['bild']);
	} else {
		$file=$_SESSION['bild'];
	}
		
	if(file_exists($file))
	{
		$groesse=getimagesize($file);
		$divisor=$groesse[0]/($_SESSION['tmpbildbreite']);
	
		$neuebreite=($groesse[0]/$divisor);
		$neuehoehe=$groesse[1]/$divisor;
		
		$image=imagecreatetruecolor($neuebreite, $neuehoehe);
		$imagesource=imagecreatefromjpeg($file);
		imagecopyresized($image, $imagesource, 0, 0, 0, 0, $neuebreite, $neuehoehe, $groesse[0], $groesse[1]);
		imagejpeg($image, $dateiname);
		imagedestroy($imagesource);
	} else {
		$image=imagecreatetruecolor(60, 50);
		$image_color = imagecolorallocate($image, 192, 192, 192);
		imagefill($image,0,0, $image_color);
		$text_color = imagecolorallocate($image, 233, 14, 91);
		imagestring($image, 1, 5, 20, 'kein Bild', $text_color);
		imagejpeg($image, $dateiname);
	}
	
	imagedestroy($image);
	ini_restore('memory_limit');
	return (0);
}

function bild_drehen($grad) {
    ini_set('memory_limit', $_SESSION['speicherlimit']);
    
   	$file=$_SESSION['bild'];

    $source = imagecreatefromjpeg($file);
    $rotate = imagerotate($source, $grad, 0);
    imagejpeg($rotate,$file,100);
	ini_restore('memory_limit');
}

function letztes_bild($v1,$v2) {
	global $link;
	$b="";
	$abfrage="Select verz1_id, verz2_id, bild from photo_daten where verz1_id='$v1' and verz2_id='$v2' order by bild";
	$erg=mysqli_query($link, $abfrage);
	while(list($verz1_id,$verz2_id,$bild)=mysqli_fetch_row($erg)){
		if($bild>$b) {
			$b=$bild;
		}
	}
	mysqli_free_result($erg);
	return $b;
}

function erstes_bild($v1,$v2) {
	global $link;
	$abfrage="Select verz1_id, verz2_id, bild from photo_daten where verz1_id='$v1' and verz2_id='$v2' order by bild";
	$erg=mysqli_query($link, $abfrage);
	list($verz1_id,$verz2_id,$bild)=mysqli_fetch_row($erg);
	mysqli_free_result($erg);
	return $bild;
}

function bild_vorhanden($v1,$v2,$b) {
	global $link;
	$abfrage="Select bild from photo_daten where verz1_id='$v1' and verz2_id='$v2' and bild='$b'";
	$erg=mysqli_query($link, $abfrage);
	$num_rows = mysqli_num_rows($erg); 
	if($num_rows > 0) {
		return 1;
		} else {
		return 0;
	}
}

function bild_export() {
	$array = explode("/",$_SESSION['bild']);
	if (copy($_SESSION['bild'], "../" . $_SESSION['bildexport'] . "/" . $array[1] . "_" . $array[2] . "_" . $array[3] )) {
		echo "<div class='aktionOK'>$array[3] exportiert</div>";
	} else {
		echo "<div class='aktionError'>Fehler beim Export von $array[3]</div>";
}
}

function bild_loeschen($v1,$v2,$n, $menge, $sm) {
	global $link;
	$a=explode("/", $_SESSION['bild']);
	$b=$a[3];

	if ($sm==1) {
		$abfrage="delete from photo_daten where verz1_id='$v1' and verz2_id='$v2' and bild='$b'";
		$erg=mysqli_query($link, $abfrage);
		if($n<$menge-2){
			$n=$n+1;
			} else {
			$n=$n-1;
			}
		} else {
		$file=albumpfad() . DIRECTORY_SEPARATOR . $a[1] . DIRECTORY_SEPARATOR . $a[2] . DIRECTORY_SEPARATOR . $b;

		if(!unlink($file)) {
			echo "!!! $file konnte auf dem Datentr&auml;ger nicht gel&ouml;scht werden !!!";
		}
		}
	return $n;
}

function hole_verzeichnisname1 ($v1) {
	global $link;
	$abfrage="select verz1_titel from photo_verz1 where verz1_id=$v1";
	$erg=mysqli_query($link, $abfrage);
	$ergverz=mysqli_fetch_object($erg);

	return($ergverz->verz1_titel);
}

function hole_verzeichnisname2 ($v2) {
	global $link;
	$abfrage="select verz2_titel from photo_verz2 where verz2_id=$v2";
	$erg=mysqli_query($link, $abfrage);
	$ergverz=mysqli_fetch_object($erg);

	return($ergverz->verz2_titel);
}

// R�ckgabewert 0 f�r nicht vorhanden oder die verz1_id fals vorhanden
function hole_verz1_id($verz1name) {
	global $link;
  $abfrage="Select verz1_id from photo_verz1 where verz1_titel like '$verz1name'";
  $erg=mysqli_query($link, $abfrage);
	$num_rows = mysqli_num_rows($erg); 
	if($num_rows > 0) {
		$ergverz=mysqli_fetch_object($erg);
		return($ergverz->verz1_id);
		} else {
		return 0;
	}
}

function hole_verz2_id($verz2name, $verz1_idtmp) {
	global $link;
	$abfrage="Select verz2_id from photo_verz2 where verz2_titel like '%$verz2name' and verz1_id=$verz1_idtmp";
	$erg=mysqli_query($link, $abfrage);
	$num_rows = mysqli_num_rows($erg); 
	if($num_rows > 0) {
		$ergverz=mysqli_fetch_object($erg);
		return($ergverz->verz2_id);
		} else {
		return 0;
	}
}

function checkbox_value($name) {
	if(isset($_POST[$name])) {
		$r=1;
	} else {
		// Wenn $_POST nicht gesetzt ist in $_GET nachschauen
		if(isset($_GET[$name])) {
			$r=1;
		} else {
			$r=0;
		}
	}
	return($r);
}

// baut die Frageparameter aus dem Suchformular zusammen, Feldinformationen befinden sich im Array $_POST
// liefert als Ergebnis ein Array zur weiterverarbeitung in frageparam1()
function frageparam_bauen($post, $pr ) {
	// bei Fragebegriff im Verzeichnisfeld Verzeichnis IDs holen
	global $link;
	
  if($post['verz2']!="") {
    $abfrage = "SELECT verz2_id from photo_verz2 where verz2_titel like '%" . $post['verz2'] . "%'";
    $erg = mysqli_query($link, $abfrage);
    $z=0;
    $num_row=mysqli_num_rows($erg);

    if(0<$num_row) {
      while($mybild=mysqli_fetch_object($erg)) {
      		$frageverz[$z][0]="or";
      		$frageverz[$z][1]="";
  			$frageverz[$z][2]="verz2_id";
      		$frageverz[$z][3]="like";
      		$frageverz[$z][4]=$mybild->verz2_id;
      		$frageverz[$z][5]="";
      		$z=$z+1;
      		}
      $frageverz[0][1]="(";
      $frageverz[0][0]="and";
      $frageverz[$z-1][5]=")";
    }
  }
  
  	// Operator f�r privat setzen
  	// Privathaken gesetzt alle < 1 anzeigen, nicht gesetzt alle >=0 anzeigen
  	if($pr) { $op_priv="<"; } else { $op_priv=">=";}
  	
	$frageparam=array(
  						array("and","","tag","like",$post['tag'],""),
  						array("and","","monat","like",$post['monat'],""),
  						array("and","","jahr","like",$post['jahr'],""),
  						array("and","","person","text",$post['person'],""),
  						array("and","","bildtext","text",$post['bildtext'],""),
  						array("and","","privat",$op_priv,"$pr","")
  					);
	// Handling Medientypen aus Suchformular
	switch($post['medientyp']) {
		case 'bilder':	array_push($frageparam,array("and","","Bild","like","%.jpg",""));
						break;
		case 'video':	array_push($frageparam,array("and","","Bild","like","%.mp4",""));
						break;		
		default:	break;
	}
	
  if($post['verz2']!="") {
  	for($z=0; $z < count($frageverz); $z++) {
  				array_push($frageparam, $frageverz[$z]);
  				}
  	}
  
return($frageparam);
}

// untersucht textfragen auf Suchw�rter und logische Operatoren
// baut aus den Einzelteilen ein Array das fragebauen1() verarbeiten kann
// zus�tzlich erfolgt die Klammersetzung
function fragebauen0($spaltenname, $textfolge) {

$textfolge=str_replace(" und "," and ",$textfolge);
$textfolge=str_replace(" oder "," or ",$textfolge);
$einzelteile=explode(" ",$textfolge);
$z=0;
$schalter=1;

$frageparam = array(array());

for ($i = 0; $i < count($einzelteile); $i++) {
			if(($einzelteile[$i]=="and" || $einzelteile[$i]=="or") && $schalter==1) {
				$frageparam[$z][0]=$einzelteile[$i];
				$z=$z+1;
				$frageparam[$z][0]=$einzelteile[$i];
				$schalter=0;
			} else {
				if(isset($frageparam[$z][4])) {
					$frageparam[$z][4]=$frageparam[$z][4] . " " . $einzelteile[$i];
					} else { $frageparam[$z][4]=" " . $einzelteile[$i]; }
				$schalter=1;
			}
			$frageparam[0][0]="and";
			$frageparam[$z][1]=" ";
			$frageparam[$z][2]=$spaltenname;
			$frageparam[$z][3]="like";
			$frageparam[$z][5]=" ";
		}
$frageparam[0][1]="(";
$frageparam[$z][5]=")";

return($frageparam);
}

function fragebauen1($frageparam) {

reset($frageparam);
$frage="";

// Arrays mit Fragetext in Funktion fragebauen0 parsen und Ergebnisse an Array anh�ngen
for ($i = 0; $i < count($frageparam); $i++) {
		if($frageparam[$i][3]=="text" && $frageparam[$i][4]!="") {
			$fragep0=fragebauen0($frageparam[$i][2], $frageparam[$i][4]);
			$frageparam[$i][4]="";
			for($i0=0; $i0 < count($fragep0); $i0++) {
				array_push($frageparam, $fragep0[$i0]);
				}
			}
// echo "Frage $i: " . $frageparam[$i][0] . " " . $frageparam[$i][1] . " " . $frageparam[$i][2] . " " . $frageparam[$i][3] . "<br>";
		}
		
// in allen Arrays mit Inhalt Leerzeichen vorne und hinten entfernen
for ($i = 0; $i < count($frageparam); $i++) {
		if($frageparam[$i][4]!="") {
			$tmp1=ltrim($frageparam[$i][4]);
			$tmp2=rtrim($tmp1);
			$frageparam[$i][4]=$tmp2;
			}
// echo "Frage $i: " . $frageparam[$i][0] . " " . $frageparam[$i][1] . " " . $frageparam[$i][2] . " " . $frageparam[$i][3] . " " . $frageparam[$i][4] ." " . $frageparam[$i][5] . "<br>";
		}

// erstes Array mit Operator where versorgen	
for ($i = 0; $i <= count($frageparam); $i++) {
		if($frageparam[$i][4]!="") {
			$frageparam[$i][0]="where ";
			break;
			}
	}

// Frage zusammenbauen	
for ($i = 0; $i < count($frageparam); $i++) {
		if($frageparam[$i][4]!="") {
			switch($frageparam[$i][3]) {
				case "gleich":
					$frage=$frage . $frageparam[$i][0] . " " . $frageparam[$i][1] . " " . $frageparam[$i][2] . "=" . $frageparam[$i][4] . " " . $frageparam[$i][5];
					break;
				case "<":
					$frage=$frage . $frageparam[$i][0] . " " . $frageparam[$i][1] . " " . $frageparam[$i][2] . " " . $frageparam[$i][3] . " " . $frageparam[$i][4] . " " . $frageparam[$i][5];
					break;
				case ">=":
					$frage=$frage . $frageparam[$i][0] . " " . $frageparam[$i][1] . " " . $frageparam[$i][2] . " " . $frageparam[$i][3] . " " . $frageparam[$i][4] . " " . $frageparam[$i][5];
					break;
				default:
					if ($frageparam[$i][2] == 'verz2_id') {
						$prozzeichen="";
					} else {
						$prozzeichen="%";
					}
					$frage=$frage . $frageparam[$i][0] . " " . $frageparam[$i][1] . " " . $frageparam[$i][2] . " " . $frageparam[$i][3] . " '$prozzeichen" . $frageparam[$i][4] . "$prozzeichen' " . $frageparam[$i][5];
					break;
			}
		}
	}
$frage=$frage . " order by sortier";
// echo "****<br>funktionen.php - Die Frage lautet:<br>$frage";
return($frage);
}

// wandelt das datumsformat vom Mysql-Format in das deutsche-Format um
function date_mysql2german($date) {
    $d    =    explode("-",$date);
    return    sprintf("%02d.%02d.%04d", $d[2], $d[1], $d[0]);
}

// wandelt das datumsformat vom deutsche Format in das Mysql-Format um
function date_german2mysql($date) {
    $d    =    explode(".",$date);
    
    return    sprintf("%04d-%02d-%02d", $d[2], $d[1], $d[0]);
}

function betriebssystem() {
	switch (true) {
		case stristr(PHP_OS, 'DAR'): return 1;
		case stristr(PHP_OS, 'WIN'): return 2;
		case stristr(PHP_OS, 'LINUX'): return 3;
		default : return 0;
	}
}

// liefert die Verzeichniswurzel des Photoalbums
function albumpfad() {
	$pfad=dirname($_SERVER['SCRIPT_FILENAME']);
	$pfad=realpath(dirname($pfad)); // realpath wegen den Gegenschrägstrichen im Windows Pfad
	return $pfad;
}

// tauscht in einem string vorder und hinerteil aus beispiel vorname nachname wird nachname vorname
function flip_string($t, $s) {
	$vn = explode( $t, $s );			// Stringteile vereinzeln
	if(count($vn)>1) {
		$nv = $vn['1'] . " " . $vn['0'];	// umdrehen
	} else {
		$nv = $vn['0'];
	}
	return($nv);
}

// zur Ausgabe von Meldungen
function raapp_log($meldung) {

	$logdatei="/var/www/raapp/raapp.log";

	$meldung=date("d-m-Y H:i:s") . ": " . $meldung . "\n";
	if (is_writable($logdatei)) {
		if (!$handle = fopen($logdatei, "a")) {
			print "Kann die Datei $logdatei nicht &ouml;ffnen";
			exit;
		}
		if (!fwrite($handle, $meldung)) {
			print "Kann in die Datei $logdatei nicht schreiben";
			exit;
		}
		fclose($handle);
	} else {
		print "Die Datei $logdatei ist nicht schreibbar";
	}
}

function setze_bilddatei() {
	// prüfen auf Bilddateien und ändern der img src im formular von Platzhalter b_name0.jpg auf korrekten Bildnamen
	// benutzt in config_xml.php und bilderupd.php
	
	$i=1;
	while($i<5) {
		$tb="images/b_name$i.jpg";
		$idb="b" . $i;
		
		if (file_exists($tb)) {
			echo "<script>document.getElementById('" . $idb . "').src='" . $tb . "'</script>";
		}
		$i++;
	}
}

function TabelleExistiert( $tabelle ) {
	global $link;
	
	$tables = mysqli_query( $link, "SHOW TABLES");
	
	mysqli_data_seek ( $tables, 0 );
	$ergebnis = FALSE;
	while ( $row = mysqli_fetch_row( $tables )) {
		// echo $row[0]."<br>";
		if ( $row[0] == $tabelle ) {
			$ergebnis = TRUE;
			break;
		}
	}
	return $ergebnis;
}

function TabelleSpalteExistiert( $tabelle, $spalte) {
	global $link;
	
	$abfrage="show columns from $tabelle";
	$spalten = mysqli_query($link, $abfrage);
	
	mysqli_data_seek ( $spalten, 0 );
	$ergebnis = FALSE;
	
	while ( $row = mysqli_fetch_row( $spalten )) {
		// echo $row[0]."<br>";
		if ( $row[0] == $spalte ) {
			$ergebnis = TRUE;
			break;
		}
	}
	return $ergebnis;
}

function TextExistiertErsetzen($file, $fileout, $suchtext, $ersatztext, $dazutext) {
	$inhalt=file_get_contents($file);
	if(!stripos($inhalt, $suchtext)) {
		$inhalt=str_replace($ersatztext, $dazutext, $inhalt);
		
		if (!$handle = fopen($fileout, "w")) { return("Kann die Datei $fileout nicht &ouml;ffnen");	}
		
		// Schreibe in die geöffnete Datei.
		if (!fwrite($handle, $inhalt)) { return("Kann in die Datei $fileout nicht schreiben"); }
		fclose($handle);
		
		return ("$dazutext an $fileout angehängt");
	} else {
		return ("$suchtext bereits vorhanden");
	}
}
?>

