<?php
/*
Copyright 2015	Matthias Rauch
www.raapp.de

Dieses Programm ist freie Software. Sie können es unter den Bedingungen der GNU General Public License,
wie von der Free Software Foundation veröffentlicht, weitergeben und/oder modifizieren,
entweder gemäß Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von Nutzen sein wird,
aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben.
Falls nicht, siehe <http://www.gnu.org/licenses/>.

*/

// GPS Info Grad Minuten Dezimalsekunden

session_start();

include("config.php");
include("funktionen.php");
pruefe_https();

if($raapp_login==1) { sessioncheck(1); }

htmlkopf();
$bild='../Jahr2015/UrlaubTürkei/IMG_20150728_171945.jpg';

// https://www.google.de/maps/place/36%C2%B032'21.1%22N+30%C2%B033'26.6%22E/@36.539207,30.5558236,17z/data=!3m1!4b1!4m2!3m1!1s0x0:0x0

echo "<img src='$bild' width='200px'>";

$ex=exif_read_data("$bild","EXIF");

// print_r($ex);

echo "<br>GPSLatitudeRef " . $ex['GPSLatitudeRef'];
$exl=$ex['GPSLatitude'];
echo " Latitude: Grad $exl[0], Minuten $exl[1], Sekunden $exl[2]";

echo "<br>GPSLongitudeRef " . $ex['GPSLongitudeRef'];
$exl=$ex['GPSLongitude'];
echo " Longitude: Grad $exl[0], Minuten $exl[1], Sekunden $exl[2]";

echo "<br>getGPS Funktion:";
$erg=getGPS($bild);
echo " Latitude: " . $erg['latitude'];
echo " Longitude: " . $erg['longitude'];

$maptext = "Rauch";
$openstreetmap = 0;

if($openstreetmap==1) {
	// **************  hier kommt die openstreetmap
	echo "<br><script type='text/javascript' src='http://www.openlayers.org/api/OpenLayers.js'></script>
	<script type='text/javascript' src='http://www.openstreetmap.org/openlayers/OpenStreetMap.js'></script>
	
	<script type='text/javascript'>
	//<![CDATA[
	
	var map;
	var layer_mapnik;
	var layer_tah;
	var layer_markers;
	
	function drawmap() {
		OpenLayers.Lang.setCode('de');
	
		// Position und Zoomstufe der Karte
		var lon = " . $erg['longitude'] . ";
		var lat = " . $erg['latitude'] . ";
		
		var zoom = 7;
		
		map = new OpenLayers.Map('map', {
			projection: new OpenLayers.Projection('EPSG:900913'),
			displayProjection: new OpenLayers.Projection('EPSG:4326'),
			controls: [
			new OpenLayers.Control.Navigation(),
			new OpenLayers.Control.LayerSwitcher(),
			new OpenLayers.Control.PanZoomBar()],
			maxExtent:
			new OpenLayers.Bounds(-20037508.34,-20037508.34,
					20037508.34, 20037508.34),
					numZoomLevels: 18,
					maxResolution: 156543,
					units: 'meters'
		});
	
		layer_mapnik = new OpenLayers.Layer.OSM.Mapnik('Mapnik');
		layer_markers = new OpenLayers.Layer.Markers('Address', {
			projection: new OpenLayers.Projection('EPSG:4326'),
			visibility: true, displayInLayerSwitcher: false });
	
			map.addLayers([layer_mapnik, layer_markers]);
			jumpTo(lon, lat, zoom);
	
			// Popup und Popuptext mit evtl. Grafik
			addMarker(layer_markers, lon, lat, \"".$maptext."\");
	}
	
	//]]>
	</script>";
	echo "<div id='menu' class='verz_button' onclick='drawmap();'>Karte</div>";
	echo "<br><br><br>
	<div id='map'>
	</div>
	<div id='osm'>© <a href='http://www.openstreetmap.org'>OpenStreetMap</a>
	und <a href='http://www.openstreetmap.org/copyright'>Mitwirkende</a>,
	<a href='http://creativecommons.org/licenses/by-sa/2.0/deed.de'>CC-BY-SA</a>
	</div>";
	
	// **************************************************
} else {
	echo "
	<script type='text/javascript' src='http://maps.googleapis.com/maps/api/js?sensor=false'></script>
	<script type='text/javascript'>
	
	function drawmap() {
		var element = document.getElementById('map');
		
		
		var map = new google.maps.Map(element, {
			center: new google.maps.LatLng(49.1063024, 8.4746999),
			zoom: 3,
		});
		
		var myLatLng = {
			lat: " . $erg['latitude'] . ", lng: " . $erg['longitude'] . "};
			var marker = new google.maps.Marker({
				position: myLatLng,
				map: map,
				title: \"".$maptext."\"});
		}
	</script>";
	echo "<div id='menu' class='verz_button' onclick='drawmap();'>Karte</div>";
	echo "wow was für eine Karte <br><br>
	<div id='map'></div>";
}

htmlfuss();

function getGPS($fileName) {
	//get the EXIF
	$exif = exif_read_data($fileName);

	//get the Hemisphere multiplier
	$LatM = 1; $LongM = 1;
	if($exif["GPSLatitudeRef"] == 'S')
	{
		$LatM = -1;
	}
	if($exif["GPSLongitudeRef"] == 'W')
	{
		$LongM = -1;
	}

//get the GPS data
$gps['LatDegree']=$exif["GPSLatitude"][0];
$gps['LatMinute']=$exif["GPSLatitude"][1];
$gps['LatgSeconds']=$exif["GPSLatitude"][2];
$gps['LongDegree']=$exif["GPSLongitude"][0];
$gps['LongMinute']=$exif["GPSLongitude"][1];
$gps['LongSeconds']=$exif["GPSLongitude"][2];

//convert strings to numbers
foreach($gps as $key => $value)
{
	$pos = strpos($value, '/');
	if($pos !== false)
	{
		$temp = explode('/',$value);
		$gps[$key] = $temp[0] / $temp[1];
	}
}

//calculate the decimal degree
$result['latitude'] = $LatM * ($gps['LatDegree'] + ($gps['LatMinute'] / 60) + ($gps['LatgSeconds'] / 3600));
$result['longitude'] = $LongM * ($gps['LongDegree'] + ($gps['LongMinute'] / 60) + ($gps['LongSeconds'] / 3600));

return $result;
}

?>
