<?php
/*
Copyright 2017	Matthias Rauch
www.raapp.de

Dieses Programm ist freie Software. Sie können es unter den Bedingungen der GNU General Public License,
wie von der Free Software Foundation veröffentlicht, weitergeben und/oder modifizieren,
entweder gemäß Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von Nutzen sein wird,
aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben.
Falls nicht, siehe <http://www.gnu.org/licenses/>.

*/
//
// die globalen Variablen aus der config.xml
// albumname		Name des Photoalbums in den Seitenüberschriften
// bbr1				Abzug Pixel von Fensterbreite für Bildbreite zur Darstellung ohne Scroolbalken
// bhr1				Abzug Pixel von Fenstherhöhe für Bildhöhe zur Darstellung ohne Scroolbalken
// szeilen			Anzahl angezeigter Zeilen in der Suchliste
// dev_vname1 dev_nname1, dev_vname2 dev_nname2, dev_vname3 dev_nname3, dev_vname4 dev_nname4	
// 					vordefinierte Namen
// tmpbildbreite	Breite des Bildes für die Suchliste
// bildpause		Pause zwischen 2 Bildern des Bilderplayers
//
// die globalen Variablen der Laufzeit
// privat			0 Normalmodus alle Bilder werden angezeigt
//					1 Privatmodus private Bilder werden nicht angezeigt
// aendern			0 Normalmodus
//					1 Modus ändern
//					2 Modus löschen
// anzahl_bilder	Gesamtanzahl der Bilder in der Playliste
// bild				kompletter Pfad zum Bild

// aus bilder photo_datem, playlist photo_playlist, t_verz1 photo_verz1, t-verz2 photo_verz2

session_start();

include("funktionen.php");
pruefe_https();

$_SESSION['photoversion']="3.1";
if(empty($_SESSION['privat'])) { 
	$_SESSION['privat']=0;
}
$_SESSION['aendern']=0;
$_SESSION['anzahl_bilder']=0;
$_SESSION['BildAnzeigeModus']=0;

function inst_form() {
	echo "<div id='container'>";
	echo "<h3>Installation raAPP Photo</h3>
	<br><h3>Bitte geben Sie die Parameter ein.</h3>
	<form method='post' action='index.php?sw=2'>
	<table class='formular'>
	<tr><th>Datenbank Name</th><td><input name='f_dbname' type='text' size='20' value='raapp'></td></tr>
	<tr><th>Hostname</th><td><input name='f_host' type='text' size='20' value='localhost'></td></tr>
	<tr><th>Datenbank Benutzername</th><td><input name='f_usr' type='text' size='20' value='root'></td></tr>
	<tr><th>Datenbank Passwort</th><td><input name='f_passw' type='password' size='20' value=''></td></tr>
	<tr><th><br><br>URL Webseite</th><td><br><br><input name='f_site' type='text' size='20' value='localhost/raapp/photo'></td></tr>
	<tr><th>Kontakt Mail</th><td><input name='f_mail' type='text' size='20' value='kontakt@raapp.de'></td></tr>
	<tr><th>Mit Benutzerverwaltung und Login/Logout</th><td><input type='checkbox' name='rlogin' value='1'></td></tr>
	</table>
	<br><input class='top_button' type='submit' value=' Konfiguration speichern '></form>
	<br><br> <br></div>";
}

function schreibe_config($post) {
	$file="config.php";
	$config="<?php
	//
	// Copyright 2017	Matthias Rauch, 76297 Stutensee
	// kontakt@raapp.de
	//
	// Variablen für Verbindung zur Datenbank\n
	\$db_name='" . $post['f_dbname'] . "';
	\$db_host='" . $post['f_host'] . "';
	\$db_user='" . $post['f_usr'] . "';
	\$db_pass='" . $post['f_passw'] . "';\n
	//zentrale Variable
	\$site_url='" . $post['f_site'] . "';			// URL Webseit
	\$site_email ='" . $post['f_mail'] . "';		// eigene eMail-Adresse
	\n";
	if(isset($post['rlogin'])) {
		if($post['rlogin']==1) {
			$config.="\$raapp_login=1;";				// mit Login und Logout
		}
	} else {
		$config.="\$raapp_login=0;";				// ohne Login und Logout
	}
	$config.="\n\$raapp_mode=0;
	?>";

	if (!$handle = fopen($file, "w")) {
		return("Kann die Datei $file nicht &ouml;ffnen");
	}

	// Schreibe in die geöffnete Datei.
	if (!fwrite($handle, $config)) {
		return("Kann in die Datei $file nicht schreiben");
	}
	fclose($handle);
	
	$file="config_default.xml";
	$newfile="config.xml";
	if (!copy($file, $newfile)) {
		return("copy $file schlug fehl...\n");
	}
	
	$dateiverzeichnis=$_SERVER['DOCUMENT_ROOT'] . DIRECTORY_SEPARATOR . "raapp" . DIRECTORY_SEPARATOR .  "db_export";
	if (file_exists($dateiverzeichnis)===FALSE) {
		// Dateiverzeichnis erzeugen
		mkdir($dateiverzeichnis);
		chmod($dateiverzeichnis, 0766);
	}
	
	return true;
}

function namen_laden() {
	global $link;
	$perso=array();

	$abfrage = "SELECT distinct person from photo_daten Group By person";
	$erg = mysqli_query($link, $abfrage);

	while($myperson=mysqli_fetch_object($erg)) {
		$pers = explode( ', ', $myperson->person );		// Personen vereinzeln
		foreach($pers as $val) {
			if(strlen($val)>0) {
				array_push($perso, $val);	// Person in das array aufnehmen Vorname Nachname
			}
		}
	}
	$_SESSION['namen']=array_unique($perso);	// Dupletten beseitigen
	natsort($_SESSION['namen']);				// array sortieren
}

function zeige_seite() {
	include("config.php");
	zeige_starttopl();
	echo "<div id='start-mitte'>
		<div id='verzzeile'> </div>
		<div id='verzzeile'><div id='menu'>Bilder - Videos</div><a class='verz_button' href='verz_anz1.php?u=0' onmouseover='InfoBoxAnzeigen(event,info[0],20,-30);' onmouseout='InfoBoxAusblenden();'><img src='../bin/images/b_anzeigen.png'></a>
			<a class='verz_button' href='bildersuch.php?sw=0'><img src='../bin/images/b_suchen.png' alt='Suchen'></a>";
	if($_SESSION['GlobalUsrtyp']==0) {
		echo " <a class='verz_button' href='verz_anz1.php?u=1' onmouseover='InfoBoxAnzeigen(event,info[4],20,-30);' onmouseout='InfoBoxAusblenden();'><img src='../bin/images/b_aendern.png'></a>";
	}
	
	if($_SESSION['GlobalUsrtyp']<2) {
		if($_SESSION['privat']==0) {
			$pbild='../bin/images/b_maske0_16x16.png';
		} else {
			$pbild='../bin/images/b_maske1_16x16.png';
		}
		echo " <a class='verz_button' href='index.php?sw=3' onmouseover='InfoBoxAnzeigen(event,info[14],20,-30);' onmouseout='InfoBoxAusblenden();'><img id='privat' src='". $pbild . "'></a>";
	} else {
		$_SESSION['privat']=1;
	}
	
	echo "</div>";
	
	if($_SESSION['GlobalUsrtyp']==0) {
		echo " <br><div id='verzzeile'><div id='menu'>Verzeichnis</div><a class='verz_button' href='bilder_laden.php?sw=0' onmouseover='InfoBoxAnzeigen(event,info[1],20,-30);' onmouseout='InfoBoxAusblenden();'><img src='../bin/images/b_verzu.png'></a>
			<a class='verz_button' href='verz_anz1.php?u=2&p=0' onmouseover='InfoBoxAnzeigen(event,info[2],20,-30);' onmouseout='InfoBoxAusblenden();'><img src='../bin/images/b_loeschen.png'></a></div>
			<div id='verzzeile'><div id='menu'>Video konvertieren</div><a class='verz_button' href='video_konv.php?sw=0'><img src='../bin/images/b_film.png' alt='Video konvertieren'></a></div>";
	}
	echo "<br><div id='verzzeile'><div id='menu'><a href='http://www.raapp.de' target='_blank'>www.raAPP.de</a></div>";
	
	if($_SESSION['GlobalUsrtyp']==0) {
		echo "<a class='verz_button' href='verwaltung.php' onmouseover='InfoBoxAnzeigen(event,info[5],20,-30);' onmouseout='InfoBoxAusblenden();'><img src='../bin/images/b_admin.png' name='Grafik3'></a>";
	}
	echo " <a class='verz_button' href='beschreibung.php'><img src='../bin/images/b_hilfe.png'></a>
		<a class='verz_button' href='info.php'><img src='../bin/images/b_info.png'></a>";
	if($raapp_login==1) {
		echo " <a class='verz_button' href='index.php?logout=1' onmouseover='InfoBoxAnzeigen(event,info[20],20,-30);' onmouseout='InfoBoxAusblenden();'><img src='../bin/images/b_logout.png'></a>";
	}
	echo "</div></div>";
	zeige_startrunten();
}

function privat_einaus() {
	if($_SESSION['privat']==0) {
		$_SESSION['privat']=1;
	} else {
		$_SESSION['privat']=0;
	}
}

function photo_login() {
	zeige_starttopl();
	echo "<div id='start-mitte'>
		<div id='start-login'>
		<div id='start-loginl'><form method='post' action=" .  htmlspecialchars($_SERVER['PHP_SELF']) . ">
		<input type='text' name='username' placeholder='Benutzerkennung' size='20'><br>
		<br><input type='password' name='passwort' placeholder='Passwort' size='20'><br>
		<br><input type='submit' name='Submit' value='Einloggen'></form></div>
		</div>
		<div id='fehlerbox'></div></div>"; // Fehlerbox wird im switch default mit Javascript gefüllt
	zeige_startrunten();
}

function loginmail($post, $empf) {
	// Mail schreiben
	$htmlkopf="<!DOCTYPE html>
	<html><head>
	<meta http-equiv='Content-Type' content='text/html; charset=UTF-8'>
	<title>raAPP Photo Login</title>
	</head><body>";
	$htmlfuss="</body></html>";
	
	$nachr="Sehr geehrter raAPP Photo Admin,<br><br>"
			. "ein Login mit der Benutzerkennung " . $post['username'] . "<br><br>"
			. "auf " . $_SERVER['HTTP_HOST'] . "<br><br>"
			. "wurde erfolgreich durchgeführt<br><br>"
			. "Mit freundlichen Grüßen<br>"
			. "raAPP Photo<br>";
	
	$nachr=$htmlkopf . $nachr . $htmlfuss;
	
	$Betreff = "raAPP Photo Login";
	$Header = "From:" . "noreply@raapp.de" . "\n";
	$Header .= "Reply-To:" . "noreply@raapp.de" . "\n";
	$Header .= "Content-type: text/html\n";

	$text = $nachr . "\n";
	mail($empf, $Betreff, $text, $Header);
}

htmlkopf();

if(!isset($_GET['sw'])) { $_GET['sw']=0; }
if(!isset($_GET['logout'])) { $_GET['logout']=0; }

if($_GET['logout']==1) {
	session_destroy();
	session_unset();
	unset($_SESSION);
}
	
// Steuerung Script
switch ($_GET['sw']) {
	case 1:		inst_form();
				break;
	case 2:		$r=schreibe_config($_POST);
				if($r==true) {
					echo "<div id='container'><h3>Die Konfiguration wurde erfolgreich gespeichert.</h3>";
					include('config.php');
					include('conf_tables.php');
					$link=db_verbinden($db_host, $db_name, $db_user, $db_pass);
					erstelle_tabellen($link, $tabellen);
					
					// Standardbenutzer kontakt@raapp.de mit Standardpasswort 12345 einrichten
					$passwh=password_hash('12345', PASSWORD_DEFAULT);
					$abfrage="INSERT into photo_usr set mailadresse='kontakt@raapp.de', passw='" . $passwh . "', typ='0', aktiv='1', bemerkung='Standardbenutzer'";
					$erg = mysqli_query($link, $abfrage);
					
					echo "<h3>Die Installation ist beendet.<br><br>raAPP Photo kann jetzt verwendet werden</h3>
					<p>Viel Spass und Erfolg mit raAPP Photo.</p>
					<p><A class='top_button' HREF='index.php'>weiter zur Startseite</A></p>";
				} else {
					echo "$r";
				}
				echo "<br></div>";
				break;
	case 3:		privat_einaus();
				zeige_seite();
				break;
	default:
				if(is_writeable('config.php')) { // raAPP Photo ist bereits installiert
					include("config.php");
					$link=db_verbinden($db_host, $db_name, $db_user, $db_pass);
					config_xml_lesen();
					if($raapp_login==1) { // mit login/logout Funktion
						if(sessioncheck(0)) {
							zeige_seite();
							namen_laden();
						} else {
							if(!check_nutzer($_POST)) {
								photo_login();
								if (isset($_SESSION['versuch']) && $_SESSION['versuch'] < 3) {
									echo "<script>document.getElementById ('fehlerbox').className='fehlerbox';
										document.getElementById ('fehlerbox').innerHTML='Login nicht erfolgreich!' + 
										'<br><br>Es stehen Ihnen noch ".	(3-$_SESSION['versuch']) . " Versuche<br> zur Verf&uuml;gung!'
										</script>";
								} else if (isset($_SESSION['versuch']) && $_SESSION['versuch'] == 3) {
									echo "<script>document.getElementById ('fehlerbox').className='fehlerbox';
										document.getElementById ('fehlerbox').innerHTML='Login nicht erfolgreich!' + 
										'<br><br>Es stehen Ihnen keine weiteren<br>Versuche zur Verf&uuml;gung!'
										</script>";
								}
							} else {
								if(strcmp($_SERVER['HTTP_HOST'], 'localhost')!==0) {
									loginmail($_POST, $site_email);	// Mail wird bei erfolgreichem login zur Sicherheit gesendet um unautorisierte Login's zu erkennen
								}
								zeige_seite();
								namen_laden();							
							}
						}
					} else { // ohne login/logout Funktion
						$_SESSION['GlobalUsrtyp']=0;	// Admin Modus setzen damit auf Startseite alle Menüpunkte hezeigt werden
						zeige_seite();
						namen_laden();
					}
				} else {
					// Damit raAPP Photo nicht aus dem Paketordner auf raApp.de gestartet werden kann
					if(strpos($_SERVER['SCRIPT_FILENAME'], "paket")===FALSE) {
						// Installation
						echo "<div id='container'>
						<h3>Installation raAPP Photo</h3>
						<h3><br>Bitte halten Sie die Zugangsdaten f&uuml;r die Datenbank auf Ihrem Server bereit.</h3>
						<h3><br><A class='top_button' HREF='index.php?sw=1'>weiter</A>
						</h3></div>";						
					} else {
						echo "<div id='container'>
						<h3>raAPP Photo kann aus diesem Verzeichnis nicht gestartet werden</h3>
						<h3><br><A class='top_button' HREF='http://www.raapp.de'>weiter</A>
						</h3></div>";
					}
				}
	}
htmlfuss();
?>